%define srcname lua
%define major 5.1
%define minor 5
%define name %{srcname}%{major}
%define libname %mklibname %{name}
%define develname %mklibname %{name} -d
%define staticname %mklibname %{name} -d -s
%define alt_priority %(echo %{major} | sed -e 's/[^0-9]//g')

Summary:	Lua is a powerful, light-weight programming language
Name:		%{name}
Version:	%{major}.%{minor}
Release:	%mkrel 2
License:	MIT
URL:		http://www.lua.org/
Group:		Development/Other
Source0:	http://www.lua.org/ftp/%{srcname}-%{version}.tar.xz
Patch0:		lua-5.1-dynlib.patch
Patch1:		lua-5.1-pkgconfig_libdir.patch
Patch2:		lua-5.1-modules_path.patch
Provides:	lua%{major}
Provides:	lua = %{version}
BuildRequires:	%{_lib}readline-devel
BuildRequires:	ncurses-devel
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Lua is a programming language originally designed for extending applications, 
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data 
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in 
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

#german
%description -l de
Lua ist eine mächtige leichtgewichtige Programmiersprache. Lua ist eine 
Programmiersprache die ursprünglich zum Erweitern von Anwendungen entworfen 
wurde, sie wird aber häufig als allgemeine, eigenständige Sprache verwendet. 
LUA kombiniert einfache prozedurale Syntax (vergleichbar mit der Pascal-Schreibweise) 
mit leistungsstarken Daten Beschreibungen, Konstrukte Grundlagen, assoziativen Arrays 
und erweiterbare Semantik. LUA wird dynamisch eingegeben, aus Bytecodes interpretiert 
und hat eine automatische Speicherverwaltung, wodurch sich ideal für Konfigurationen, 
Skripte und schnelle Prototypen eignet. LUA wird als eine kleine Bibliothek von 
C-Funktionen in ANSI C geschrieben sowie kompiliert und unverändert in allen bekannten 
Plattformen implementiert. Die Implementierungsziele sind Einfachheit Effizienz, 
Portabilität und niedrige Kosten mit einander zu verbinden.

%package -n %{libname}
Summary:	Lua is a powerful, light-weight programming language
Group:		System/Libraries

%description -n %{libname}
Lua is a programming language originally designed for extending applications,
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

This package includes the libraries.

#german
%description -n %{libname} -l de
Lua ist eine mächtige leichtgewichtige Programmiersprache. Lua ist eine 
Programmiersprache die ursprünglich zum Erweitern von Anwendungen entworfen 
wurde, sie wird aber häufig als allgemeine, eigenständige Sprache verwendet. 
LUA kombiniert einfache prozedurale Syntax (vergleichbar mit der Pascal-Schreibweise) 
mit leistungsstarken Daten Beschreibungen, Konstrukte Grundlagen, assoziativen Arrays 
und erweiterbare Semantik. LUA wird dynamisch eingegeben, aus Bytecodes interpretiert 
und hat eine automatische Speicherverwaltung, wodurch sich ideal für Konfigurationen, 
Skripte und schnelle Prototypen eignet. LUA wird als eine kleine Bibliothek von 
C-Funktionen in ANSI C geschrieben sowie kompiliert und unverändert in allen bekannten 
Plattformen implementiert. Die Implementierungsziele sind Einfachheit Effizienz, 
Portabilität und niedrige Kosten mit einander zu verbinden.

%package -n %{develname}
Summary:	Headers and development files for Lua
Group:		Development/Other
Requires:	%{libname} = %{version}-%{release}
# to have the same provides on all arches
Provides:	lua%{major}-devel = %{version}-%{release}
Provides:	lua-devel = %{version}-%{release}
# for backward compat
Provides:	liblua-devel = %{version}-%{release}
# conflict with other versions
Conflicts:	lua-devel < %{version}
Conflicts:	lua-devel > %{version}
Conflicts:	%{libname}-devel-static < %{version}
Conflicts:	%{libname}-static-devel < %{version}

%description -n %{develname}
This package contains the headers and development files for Lua.

#german
%description -n %{develname} -l de
Dieses Paket enthält die Header und Entwicklungsdateien für LUA.

%package -n %{staticname}
Summary:	Static development files for Lua
Group:		Development/Other
Requires:	%{develname} = %{version}
# to have the same provides on all arches
Provides:	lua-devel-static = %{version}-%{release}
Provides:	lua%{major}-devel-static = %{version}-%{release}
# conflict with other versions
Conflicts:	lua-devel-static < %{version}
Conflicts:	lua-devel-static > %{version}
Conflicts:	%{libname}-devel-static < %{version}
Conflicts:	%{libname}-static-devel < %{version}

%description -n %{staticname}
This package contains the static development files for Lua.

#german
%description -n	%{staticname} -l de
Dieses Paket enthält die statischen Entwicklungs-Dateien für Lua.

%prep
%setup -q -n %{srcname}-%{version}
%patch0 -p1 -b .dynlib
%patch1 -p1 -b .pkgconfig
%patch2 -p1 -b .modules

sed -i -e "s|/usr/local|%{_prefix}|g" src/luaconf.h
sed -i -e "s|/lib|/%{_lib}|g" src/luaconf.h

%build

%make \
    linux CFLAGS="%{optflags} -fPIC -DLUA_USE_LINUX" \
    INSTALL_TOP=%{_prefix} \
    INSTALL_BIN=%{_bindir} \
    INSTALL_INC=%{_includedir} \
    INSTALL_LIB=%{_libdir} \
    INSTALL_MAN=%{_mandir}/man1

sed -i -e "s#/usr/local#%{_prefix}#" etc/lua.pc
sed -i -e 's/-lreadline -lncurses //g' etc/lua.pc

%install
rm -rf %{buildroot}

%makeinstall_std \
    INSTALL_TOP=%{buildroot}%{_prefix} \
    INSTALL_LIB=%{buildroot}%{_libdir} \
    INSTALL_MAN=%{buildroot}%{_mandir}/man1

install -d %{buildroot}%{_libdir}/lua/%{major}/
install -d %{buildroot}%{_datadir}/lua/%{major}/
install -m 644 test/*.lua %{buildroot}%{_datadir}/lua/%{major}/

install -m 755 src/liblua.so.%{major}* %{buildroot}%{_libdir}
ln -s liblua.so.%{major} %{buildroot}%{_libdir}/liblua.so

install -d -m 755 %{buildroot}%{_libdir}/pkgconfig/
install -m 644 etc/lua.pc %{buildroot}%{_libdir}/pkgconfig/

# for update-alternatives
mv %{buildroot}%{_bindir}/lua %{buildroot}%{_bindir}/lua%{major}
mv %{buildroot}%{_bindir}/luac %{buildroot}%{_bindir}/luac%{major}

%clean
rm -rf $RPM_BUILD_ROOT

%post
/usr/sbin/update-alternatives --install %{_bindir}/lua lua %{_bindir}/lua%{major} %{alt_priority} --slave %{_bindir}/luac luac %{_bindir}/luac%{major}

%post -n %{libname}
/sbin/ldconfig

%postun
[[ -f %{_bindir}/lua%{major} ]] || /usr/sbin/update-alternatives --remove lua %{_bindir}/lua%{major}

%postun -n %{libname}
/sbin/ldconfig


%files
%defattr (-,root,root)
%doc COPYRIGHT HISTORY INSTALL README
%doc doc/*.html doc/*.gif
%{_bindir}/*
%{_datadir}/lua/%{major}/*.lua
%{_mandir}/man1/*

%files -n %{libname}
%defattr (-,root,root)
%{_libdir}/*.so.*

%files -n %{develname}
%defattr (-,root,root)
%{_includedir}/*
%{_libdir}/pkgconfig/*
%{_libdir}/*.so

%files -n %{staticname}
%defattr (-,root,root)
%{_libdir}/*.a


%changelog
* Mon Nov 06 2017 bb2 <bb2> - 5.1.5-2pclos2017
- rebuild against updates

* Tue Oct 16 2012 Neal <nealbrks0 at gmail dot com> 5.1.5-1pclos2012
- process

* Thu Oct 04 2012 gseaman <galen.seaman at comcast.net> 5.1.5-1gseaman2012
- update 5.1.5

* Fri Aug 24 2012 gseaman <galen.seaman at comcast.net> 5.1.4-3pclos2012
- changed Requires libreadline-devel to %{_lib}readline-devel

* Tue Jul 10 2012 Neal <nealbrks0 at gmail dot com> 5.14-2pclos2012
- rebuild

* Mon Apr 27 2009 pcserver <pcserver@husmail.com> 5.14-1pclos2009
- 5.14
